var p4200 = null;
var unlocked = false;
var socket;
var skip = false;
Number.prototype.pad = function(size) {
	var s = String(this);
	while (s.length < (size || 2)) {
		s = "0" + s;
	}
	return s;
}
/**
 * Open a new WebSocket connection using the given parameters
 */
function setupWebSocket(webSocket) {
	try {
		webSocket.onopen = function(openEvent) {
			console
					.log("WebSocket OPEN: "
							+ JSON.stringify(openEvent, null, 4));

		};
		webSocket.onclose = function(closeEvent) {
			console.log("WebSocket CLOSE: "
					+ JSON.stringify(closeEvent, null, 4));
		};
		webSocket.onerror = function(errorEvent) {
			console.log("WebSocket ERROR: "
					+ JSON.stringify(errorEvent, null, 4));
		};
		webSocket.onmessage = function(messageEvent) {
			var wsMsg = messageEvent.data;
			//console.log("WebSocket MESSAGE: " + wsMsg);
			p4200 = JSON.parse(wsMsg);
			updateLockIcon();
			if (!skip) {
				updateExtendedAlarmDelayEnabled();
				updateCompressorRuntime();
				updateBranding();
			} else {
				skip = false;
			}

		};
		socket = webSocket;
	} catch (exception) {
		console.error(exception);
	}
}

function updateExtendedAlarmDelayEnabled() {
	if (p4200.extendedAlarmDelayEnabled == true) {
		document.getElementById('ex_delay_on').checked = true;
		document.getElementById('ex_delay_off').checked = false;
	} else {
		document.getElementById('ex_delay_on').checked = false;
		document.getElementById('ex_delay_off').checked = true;
	}

}

function clearEventLog() {
	if (isUnlocked()) {
		sendCommand(socket, "CLEAR EVENT LOG");
	}

}
function setExtendedAlarmDelay(enabled) {
	if (isUnlocked()) {
		skip = true;
		if (enabled) {
			sendCommand(socket, "ENABLE EXTENDED ALARM DELAY");
			document.getElementById('ex_delay_on').checked = true;
			document.getElementById('ex_delay_off').checked = false;
		} else {
			sendCommand(socket, "DISABLE EXTENDED ALARM DELAY");
			document.getElementById('ex_delay_on').checked = false;
			document.getElementById('ex_delay_off').checked = true;
		}
	}

}

function updateBranding() {
	console.log(p4200.branding)
	if (p4200.branding == "Altec-Air") {
		document.getElementById('altec-air-branding').checked = true;
		document.getElementById('rfs-branding').checked = false;
	} else {
		document.getElementById('altec-air-branding').checked = false;
		document.getElementById('rfs-branding').checked = true;
	}

}
function setBranding(brand) {
	if (isUnlocked()) {
		skip = true;
		console.log("Brand " + brand)
		sendCommand(socket, "SET BRANDING", brand);
		if (brand == "Altec-Air") {
			document.getElementById('altec-air-branding').checked = true;
			document.getElementById('rfs-branding').checked = false;

		} else {
			document.getElementById('altec-air-branding').checked = false;
			document.getElementById('rfs-branding').checked = true;
		}
	}

}
function updateCompressorRuntime() {
	var compressorTotalRuntimeHours = p4200.systems[0].compressorTotalRuntimeHours;
	if (document.getElementById('compressor_runtime') != document.activeElement) {
		document.getElementById('compressor_runtime').value = compressorTotalRuntimeHours;
	}
}

function setCompressorRuntime(event) {
	var input = document.getElementById('compressor_runtime');
	var threshold = input.value;
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			if (isNaN(input.value)) {
				alert("Please Enter a Number");
				input.blur();
				return;
			}
			if (withinRange(0, 10000, input.value)) {
				sendCommand(socket,"SET COMPRESSOR TOTAL RUNTIME", input.value);
			}
			else {
				alert("Input out of range");
			}

				input.blur();
	
		}
	}
}