
var tableData;
var AlarmFilter = true;
var ParamChangeFilter = true;
var InfoFilter = true;
var clicked = true;
var p4200;
var socket;
var dbwebSocket;

function convertToCSV(objArray) {
    var array = typeof objArray != 'object' ? JSON.parse(objArray) : objArray;
    var str = '';

    for (var i = 0; i < array.length; i++) {
        var line = '';
        for (var index in array[i]) {
            if (line != '') line += ','

            line += array[i][index];
        }

        str += line + '\r\n';
    }

    return str;
}

function exportCSVFile(headers, items, fileTitle) {
    if (headers) {
        items.unshift(headers);
    }

    // Convert Object to JSON
    var jsonObject = JSON.stringify(items);

    var csv = this.convertToCSV(jsonObject);

    var exportedFilenmae = fileTitle + '.csv' || 'export.csv';

    var blob = new Blob([csv], { type: 'text/csv;charset=utf-8;' });
    if (navigator.msSaveBlob) { // IE 10+
        navigator.msSaveBlob(blob, exportedFilenmae);
    } else {
        var link = document.createElement("a");
        if (link.download !== undefined) { // feature detection
            // Browsers that support HTML5 download attribute
            var url = URL.createObjectURL(blob);
            link.setAttribute("href", url);
            link.setAttribute("download", exportedFilenmae);
            link.style.visibility = 'hidden';
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
        }
    }
}

function hasUndefined(item)
{

	if(item.eventtype === undefined)
	{
		console.log("eventtype undefined")
		return true
	}

	if(item.description === undefined)
	{
		console.log("description undefined")
		return true
	}
	if(item.timestamp === undefined)
	{
		console.log("timestamp undefined")
		return true
	}
	if(item.eventtype == "Alarm")
	{
		if(item.tankpressure === undefined)
		{
			console.log("tankpressure undefined")
			return true
		}
		if(item.outletpressure === undefined)
		{
			console.log("outletpressure undefined")
			return true
		}
		if(item.flow === undefined)
		{
			console.log("flow undefined")
			return true
		}
		if(item.systemonehumidity === undefined)
		{
			console.log("systemonehumidity undefined")
			return true
		}
		if(item.systemonedutycycle === undefined)
		{
			console.log("systemonedutycycle undefined")
			return true
		}
		if(item.systemonelastruntime === undefined)
		{
			console.log("systemonelastruntime undefined")
			return true
		}
		if(item.compressortemp === undefined)
		{
			console.log("compressortemp undefined")
			return true
		}
		if(item.cabinettemp === undefined)
		{
			console.log("cabinettemp undefined")
			return true
		}
	}


	return false


}
function download(){
  var headers = {
      eventtype: 'Event Type'.replace(/,/g, ''), // remove commas to avoid errors
      description: "Description",
	  tankpressure: "Tank Pressure (PSI)",
	  outletpressure: "Outlet Pressure (PSI)",
	  flow: "Flow (SCFD)",
	  systemonehumidity: "S1 Humidity (%)",
	  systemonedutycycle: "S1 Duty Cycle (%)",
	  systemonelastruntime: "S1 Last Runtime (MIN)",
	  compressortemp: "Compressor Temp (Deg F)",
	  cabinettemp: "Cabinet Temp (Deg F)",
      timestamp: "Timestamp"
  };

  itemsNotFormatted = tableData;
  var itemsFormatted = [];
  var fileTitle
  itemsNotFormatted.reverse();
  // format the data
  itemsNotFormatted.forEach((item) => {
	if(hasUndefined(item))
	{
		console.log("undefined found in row")
		console.log(item)
	}
	else
	{
		var date = new Date(+item.timestamp)
		date.setMinutes(date.getMinutes() + date.getTimezoneOffset())
		if(item.eventtype == "Alarm")
		{
			itemsFormatted.push({
				eventtype: item.eventtype.replace(/,/g, ''), // remove commas to avoid errors,
				description: item.description,
				tankpressure: item.tankpressure.toFixed(1),
				outletpressure: item.outletpressure.toFixed(1),
				flow: item.flow.toFixed(0),
				systemonehumidity: item.systemonehumidity.toFixed(1),
				systemonedutycycle: item.systemonedutycycle.toFixed(0),
				systemonelastruntime: item.systemonelastruntime,
				compressortemp: item.compressortemp.toFixed(0),
				cabinettemp: item.cabinettemp.toFixed(0),
				timestamp: date.toLocaleString()

			});

		}
		else
		{
			itemsFormatted.push({
				eventtype: item.eventtype.replace(/,/g, ''), // remove commas to avoid errors,
				description: item.description,
				tankpressure: "n/a",
				outletpressure: "n/a",
				flow: "n/a",
				systemonehumidity: "n/a",
				systemonedutycycle: "n/a",
				systemonelastruntime: "n/a",
				compressortemp: "n/a",
				cabinettemp: "n/a",
				timestamp: date.toLocaleString()

			});
		}
	}





  });


  fileTitle = new Date().toLocaleString() + "_Log"
  exportCSVFile(headers, itemsFormatted, fileTitle); // call the exportCSVFile() function to process the JSON and trigger the download
}

function filterMenuClick() {
	document.getElementById("myDropdown").classList.toggle("show");
}
function alarmFilterClick()
{
	if(document.getElementById("alarmFilterButton").checked)
	{
		AlarmFilter = true;
	}
	else
	{

		AlarmFilter = false;
	}
	requestUpdate();
}
function paramFilterClick()
{
	if(document.getElementById("paramFilterButton").checked)
	{
		ParamChangeFilter = true;
	}
	else
	{

		ParamChangeFilter = false;
	}
	requestUpdate();
}
function infoFilterClick()
{
	if(document.getElementById("infoFilterButton").checked)
	{
		InfoFilter = true;
	}
	else
	{

		InfoFilter = false;
	}
	requestUpdate();
}
//Close the dropdown menu if the user clicks outside of it
window.onclick = function(event) {
	if (!event.target.matches('.dropbtn')) {
		var dropdowns = document.getElementsByClassName("dropdown-content");
		var i;
		for (i = 0; i < dropdowns.length; i++) {
			var openDropdown = dropdowns[i];
			if (openDropdown.classList.contains('show')) {
				openDropdown.classList.remove('show');
			}
		}
	}
}
Number.prototype.pad = function(size) {
	var s = String(this);
	while (s.length < (size || 2)) {s = "0" + s;}
	return s;
}
/**
 * Open a new WebSocket connection using the given parameters
 */
function setupDBSocket(webSocket)
{
	try {

		webSocket.onopen = function(openEvent) {
			console.log("WebSocket OPEN: " + JSON.stringify(openEvent, null, 4));
			requestUpdate();

		};
		webSocket.onclose = function (closeEvent) {
			console.log("WebSocket CLOSE: " + JSON.stringify(closeEvent, null, 4));
		};
		webSocket.onerror = function (errorEvent) {
			console.log("WebSocket ERROR: " + JSON.stringify(errorEvent, null, 4));
		};
		webSocket.onmessage = function (messageEvent) {
			var wsMsg = messageEvent.data;
			console.log("WebSocket MESSAGE: " + wsMsg);
			tableData = JSON.parse(wsMsg);
			console.log(tableData[0].description)
			if(p4200 != null)
			{
				appendJSON(tableData);
			}
			else
			{
				requestUpdate();
			}
			
		};
		dbwebSocket = webSocket;
	} catch (exception) {
		console.error(exception);
	}
}
function setupDryerSocket(webSocket)
{
	try {

		webSocket.onopen = function(openEvent) {
			console.log("WebSocket OPEN: " + JSON.stringify(openEvent, null, 4));
			

		};
		webSocket.onclose = function (closeEvent) {
			console.log("WebSocket CLOSE: " + JSON.stringify(closeEvent, null, 4));
		};
		webSocket.onerror = function (errorEvent) {
			console.log("WebSocket ERROR: " + JSON.stringify(errorEvent, null, 4));
		};
		webSocket.onmessage = function (messageEvent) {
			var wsMsg = messageEvent.data;
			//console.log("WebSocket MESSAGE: " + wsMsg);
			p4200 = JSON.parse(wsMsg);

		};
		socket = webSocket;
	} catch (exception) {
		console.error(exception);
	}
}


//this function appends the json data to the table 'gable'
function appendJSON(data){
	var table = document.getElementById('tableBody');
	var newTbody  = document.createElement('tbody');
	newTbody.id = "newTbody"

	newTbody.className = "tbstyle"
		data.forEach(function(object) {

			if(hasUndefined(object))
			{
				console.log("undefined found in row")
				console.log(object)
			}
			else
			{
				var date = new Date(+object.timestamp)
				date.setMinutes(date.getMinutes() + date.getTimezoneOffset())
				var tr = document.createElement('tr');

				tr.className = "tableRowStyle"
				if(object.eventtype == "Info")
				{
					tr.style.backgroundColor = "#52d073"
					tr.style.color = "black";
				}
				else if(object.eventtype == "Alarm")
				{
					tr.style.backgroundColor = "#df7354"
					tr.style.color = "black";
					tr.tabIndex = '0';
				}
				else if(object.eventtype == "Parameter Change")
				{
					tr.style.backgroundColor = "#42badc"
					tr.style.color = "black";
				}

				if (object.eventtype == "Alarm" && AlarmFilter == true) {
					cabinColor = getColor(object.cabinettemp, p4200.highCabinetTemperatureThreshold, 0);
					compressorTempColor = getColor(object.compressortemp, p4200.highCompressorTemperatureThreshold, 0);
					s1DutyColor = getColor(object.systemonedutycycle, p4200.highDutyCycleThreshold, 0);
					s1HumColor = getColor(object.systemonehumidity, p4200.highHumidityThreshold, 0);
					flowColor = getColor(object.flow, p4200.highFlowThreshold, 0);
					outColor = getColor(object.outletpressure, p4200.highOutletPressureThreshold, p4200.lowOutletPressureThreshold);
					let compTemp
					if (object.compressortemp) {

						compTemp = object.compressortemp
					}
					else
					{
						console.log("Comptemp IS NULL")
						compTemp = 0.0
						console.log(object)

					}


					tr.innerHTML =
						'<td class = "eventTypeData">' + object.eventtype + '</td>' +
						'<td class = "descriptionData">' + object.description +
						'<span class="spnTooltip"><table><tr><td>Cabinet Temp:</td><td style = "color: ' + cabinColor + ';id = "cabinetTemp">' + object.cabinettemp.toFixed(0) + ' &degF</td></tr>' +
						'<tr><td>Compressor Temp:</td><td style = "color: ' + compressorTempColor + ';id = "compressorTemp">' + compTemp.toFixed(0) + ' &degF</td></tr>' +
						'<tr><td>System 1 Last Runtime:</td><td id = "s1lr">' + object.systemonelastruntime + ' Min</td></tr>' +
						'<tr><td>System 1 Duty Cycle:</td><td style = "color: ' + s1DutyColor + ';id = "systemOneDuty">' + object.systemonedutycycle.toFixed(0) + ' %</td></tr>' +
						'<tr><td>System 1 Humidity:</td><td style = "color: ' + s1HumColor + ';"id = "systemOneHumidity">' + object.systemonehumidity.toFixed(1) + ' %</td></tr>' +
						'<tr><tr><td>Flow:</td><td style = "color: ' + flowColor + ';id = "Flow">' + object.flow.toFixed(0) + ' SCFD</td></tr>' +
						'<tr><td>Outlet Pressure:</td><td style = "color: ' + outColor + ';id = "outletPressure">' + object.outletpressure.toFixed(1) + ' PSI</td></tr>' +
						'<tr><td>Tank Pressure:</td><td id = "tankPressure">' + object.tankpressure.toFixed(1) + ' PSI</td></tr></table></span></td>' +
						'<td class = "timestampData">' + date.toLocaleString() + '</td>';
					newTbody.appendChild(tr);


				} else if (object.eventtype == "Parameter Change" && ParamChangeFilter) {
					tr.innerHTML =
						'<td class = "eventTypeData">' + object.eventtype + '</td>' +
						'<td class = "descriptionData">' + object.description + '</td>' +
						'<td class = "timestampData">' + date.toLocaleString() + '</td>';
					newTbody.appendChild(tr);
				} else if (object.eventtype == "Info" && InfoFilter) {
					tr.innerHTML =
						'<td class = "eventTypeData">' + object.eventtype + '</td>' +
						'<td class = "descriptionData">' + object.description + '</td>' +
						'<td class = "timestampData">' + date.toLocaleString() + '</td>';
					newTbody.appendChild(tr);

				}
			}

		});
	if(table != null)
	{
		console.log("HERE")
		table.replaceChild(newTbody, table.childNodes[0]);
		$('tbody').each(function(){
			var list = $(this).children('tr');
			$(this).html(list.get().reverse())
		});
	}



}
function getColor(number, highThreshold, lowThreshold)
{
	if (number > highThreshold || number < lowThreshold) {
		return "red"
	}
	else {
		return "black"
	}
}

function requestUpdate()
{
	sendMessage(dbwebSocket,"UPDATE EVENT TABLE");
}



