package com.AltecAir.P4200.web.server;

import java.io.IOException;

import com.AltecAir.P4200.org.nanohttpd.protocols.http.IHTTPSession;
import com.AltecAir.P4200.org.nanohttpd.protocols.websockets.CloseCode;
import com.AltecAir.P4200.org.nanohttpd.protocols.websockets.NanoWSD;
import com.AltecAir.P4200.org.nanohttpd.protocols.websockets.WebSocket;
import com.AltecAir.P4200.org.nanohttpd.protocols.websockets.WebSocketFrame;
import com.AltecAir.P4200.System.P4200;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;

public class DatabaseWebSocketServer extends NanoWSD
{
	private P4200 p4200;
	private DatabaseWebSocket websocket;

	public DatabaseWebSocketServer(int port, P4200 p4200)
	{
		super(port);
		this.p4200 = p4200;
	}

	public P4200 getP4200()
	{
		return p4200;
	}

	public void update()
	{
		if (websocket != null && websocket.isOpen())
		{
			websocket.update();
		}

	}

	public void ping()
	{

		if (websocket != null && websocket.isOpen())
		{
			try
			{
				websocket.ping(new byte[]
				{ 0xA });
			}
			catch (IOException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	@Override
	protected WebSocket openWebSocket(IHTTPSession handshake)
	{
		// TODO Auto-generated method stub
		this.websocket = new DatabaseWebSocket(this, handshake);
		return websocket;
	}

	private static class DatabaseWebSocket extends WebSocket
	{
		private final DatabaseWebSocketServer server;
		private ObjectMapper mapper = new ObjectMapper();

		private String getCommand(String message)
		{
			if (message.contains(","))
			{
				return message.substring(0, message.indexOf(','));
			}
			else
			{
				return message;
			}

		}

		public DatabaseWebSocket(DatabaseWebSocketServer server, IHTTPSession handshakeRequest)
		{
			super(handshakeRequest);
			mapper.configure(SerializationFeature.FAIL_ON_EMPTY_BEANS, false);
			this.server = server;

		}

		@Override
		protected void onOpen()
		{
			// TODO Auto-generated method stub

		}

		@Override
		protected void onClose(CloseCode code, String reason, boolean initiatedByRemote)
		{
			// TODO Auto-generated method stub

		}

		@Override
		protected void onMessage(WebSocketFrame message)
		{
			String payload = message.getTextPayload();
			switch (getCommand(payload))
			{
			case "UPDATE EVENT TABLE":
			{
				server.getP4200().database().setUpdateAvailable();
				break;
			}
			}

		}

		@Override
		protected void onPong(WebSocketFrame pong)
		{

		}

		@Override
		protected void onException(IOException exception)
		{
			// TODO Auto-generated method stub

		}

		public void update()
		{
			try
			{
				String json = server.getP4200().database().getTable();
				send(json);
			}
			catch (JsonProcessingException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			catch (IOException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

}
